/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _ma_new.c,v 1.1.1.1 1993/04/18 16:23:44 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <limits.h>
#include <sys/xstart.h>
#include <sys/xstdlib.h>

/* External variables */
int _ma_fnum=0;
char *_ma_flist=0;
char *_ma_lptr=0;

short gram_uok=0;
short tram_uok=0;
static char gram_is_used=0;
static char tram_is_used=0;

extern compiler_says(const char *);

/* Functions */
char *_ma_new (size_t size)
{
    long more;				/* Kvȃq[v̗ */
    char *alloc;			/* V蓖ăAhX */

    /*
    ** ubN̍Ō̃AhX𓾂BubN̍Ōオ
    ** o^ĂȂ悤ȂA_hsta + 4 lƂēo^B
    ** A_hsta 擪ʎq 4 oCgށB
    */
    if ((alloc = _ma_lptr) == 0) {
	alloc = _hsta + 4;
	MA_BFLAG (alloc) = MA_VALUE (MA_EXIT, 0);
    }

    /*
    ** ubN̍Ō̃AhX size oCgq[v̈
    ** ɊmۂƂꍇɑȂ̃oCgvZB
    */
    more = alloc + size + 4 - (char *) _last;

    /*
    ** ȂʂȂΗ̈g傷B̍ہAu[Nl
    ** ̓y[WTCY(4K)o_ŊgBŌ̏I[
    **  4 oCg܂ށBgɎsꍇ̓G[^[B
    */
    if (more > 0) {
	if ((int) sbrk (more) < 0)

/* T.Kanazawa / KYA soft addition */
	if(gram_uok && !gram_is_used && (size<0x7ff00)){

		gram_is_used=1;
		_dos_super(0);
        fprintf (stderr, "Message:%s\n", "Gram蓖Ă܂");
{
    extern char *_ma_lptr;
    extern void *_last;

    long more;				/* Kvȃq[v̗ */

    /*
    ** ubN̍Ō̃AhX𓾂BubN̍Ōオ
    ** o^ĂȂ悤ȂA_hsta + 4 lƂēo^B
    ** A_hsta 擪ʎq 4 oCgށB
    */
    if (_ma_lptr == 0) {
	abort();
    }

    more = 0xc00000 - (unsigned long)_ma_lptr +4;
    /*
    ** VɎZoubNubNI[ƂA
    ** ɏI[ʎq𖄂ߍށB
    */
    MA_FFLAG (_ma_lptr) = MA_VALUE (MA_USED, more);

    _last = 0xc7ff40;
    _ma_lptr = 0xc00004;

    MA_BFLAG (_ma_lptr) = MA_VALUE (MA_USED, more);
    MA_FFLAG (_ma_lptr) = MA_VALUE (MA_EXIT, 0xffffff);
    alloc = _ma_lptr;

}
	} else if(tram_uok && !tram_is_used && (size<0x3ff00)){
		tram_is_used=1;
		if(!gram_is_used)_dos_super(0);
        fprintf (stderr, "Message:%s\n", "Tram蓖Ă܂");
{
    extern char *_ma_lptr;
    extern void *_last;

    long more;				/* Kvȃq[v̗ */

    /*
    ** ubN̍Ō̃AhX𓾂BubN̍Ōオ
    ** o^ĂȂ悤ȂA_hsta + 4 lƂēo^B
    ** A_hsta 擪ʎq 4 oCgށB
    */
    if (_ma_lptr == 0) {
	abort();
    }

    more = 0xe40000 - (unsigned long)_ma_lptr +4;
    /*
    ** VɎZoubNubNI[ƂA
    ** ɏI[ʎq𖄂ߍށB
    */
    MA_FFLAG (_ma_lptr) = MA_VALUE (MA_USED, more);

    _last = 0xe7ff40;
    _ma_lptr = 0xe40004;

    MA_BFLAG (_ma_lptr) = MA_VALUE (MA_USED, more);
    MA_FFLAG (_ma_lptr) = MA_VALUE (MA_EXIT, 0xffffff);
    alloc = _ma_lptr;

}
	} else return 0;
    }
    /*
    ** VɎZoubNubNI[ƂA
    ** ɏI[ʎq𖄂ߍށB
    */
    _ma_lptr = alloc + size;
    MA_FFLAG (_ma_lptr) = MA_VALUE (MA_EXIT, 0xffffff);

    /*
    ** AhXԂB
    */
    return alloc;
}
